#include "global.h"
void write_files(files)
     Name *files;
{
  int do_file;
  while (files) {
    write_files(files->llink);
    do_file = ! make_flag;
    if ( make_flag ) do_file = ! strcmp(make_name,files->spelling);
    if ( do_file ) {
                     char indent_chars[500];
                     int file_updated = 0;
                     FILE *temp_file;
                     char *temp_name = tempnam(".", 0);
                     temp_file = fopen(temp_name, "w");
                     if (!temp_file) {
                       fprintf(stderr, "%s: can't create %s for a temporary file\n",
                               command_name, temp_name);
                       exit(-1);
                     }  
                     if (verbose_flag)
                       fprintf(stderr, "writing %s\n", files->spelling);
                     write_scraps(temp_file, files->defs, 0, indent_chars,
                                  files->debug_flag, files->tab_flag, files->indent_flag);
                     fclose(temp_file);
                     if (compare_flag)
                       {
                         FILE *old_file = fopen(files->spelling, "r");
                         if (old_file) {
                           int x, y;
                           temp_file = fopen(temp_name, "r");
                           do {
                             x = getc(old_file);
                             y = getc(temp_file);
                           } while (x == y && x != EOF);
                           fclose(old_file);
                           fclose(temp_file);
                           if (x == y)
                             remove(temp_name);
                           else {
                             file_updated = 1;
                             remove(files->spelling);
                             rename(temp_name, files->spelling);
                           }
                         }
                         else
                           file_updated = 1;
                           rename(temp_name, files->spelling);
                       }
                     else {
                       file_updated = 1;
                       remove(files->spelling);
                       rename(temp_name, files->spelling);
                     }
                     if (write_flag && file_updated)
                       fprintf(stderr, "written %s\n", files->spelling);
                   }
    files = files->rlink;
  }
}
